/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.engineering;

import engcalculator.function.infix.*;
import engcalculator.function.infix.arithmetic.Sum;
import engcalculator.data.Interval;
import engcalculator.function.prefix.interval.Invert;

/**
 *
 * @author simone
 */
public class SumInverted extends DualInputSingleOutputInfixFunction {
    private static Sum ADD = new Sum();
    private static Invert INVERT = new Invert();
    private final static String[] EXAMPLE_LEFT = {"2_4"};
    private final static String[] EXAMPLE_RIGHT = {"4_6"};
    private final static String[] RESULT = {"1.333333333_2.4"};

    public SumInverted() {
        super ("+/", true, true, "a +/ b adds the inverse of the given vector of intervals and then inverts again the result: 1/(1/a+1/b).", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval _computeIntervals(Interval left, Interval right) throws Exception {
        return INVERT._computeIntervals(ADD._computeIntervals(INVERT._computeIntervals(left), INVERT._computeIntervals(right)));
    }
}
