/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.interval;

import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;

/**
 *
 * @author simone
 */
public class IntervalByExtremesBuilder extends DualInputSingleOutputInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"2","3"};
    private final static String[] EXAMPLE_RIGHT = {"4","5"};
    private final static String[] RESULT = {"2_4","3_5"};

    public IntervalByExtremesBuilder() {
        super("_", true, true, "a_b generates an interval with a and b as extremes.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }


    @Override
    public Interval _computeIntervals (Interval leftSide, Interval rightSide) throws Exception {
        return new Interval (leftSide.getVal(), rightSide.getVal());
    }

}
