/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.space;

import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.arithmetic.Sum;

/**
 *
 * @author simone
 */
public class IncSpace extends PrefixFunction {
    private final static Sum SUM = new Sum ();

    private final static String[] EXAMPLE = {"4, 2, 10"};
    private final static String[] RESULT = {"(10, 12, 14, 16)"};

    public IncSpace() {
        super("incspace", (byte) 3, true, true, "incspace (noi, increment, start) generates a list of noi intervals from start with given increment.", EXAMPLE, RESULT);
    }


    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        final int s = (int) input.getFirst().getVal();
        final IntervalList increment = input.subList(1, 2);
        IntervalList result = new IntervalList ();
        IntervalList start = input.subList(2, 3);
        for (int i = 0; i<s; ++i) {
            result.add(start.getFirst());
            start = SUM._compute(start, increment);
        }
        return result;
    }

}
