/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.square;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Square extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_2, -10_-2, 5_7, -7_-5"};
    private final static String[] RESULT = {"0_100, 4_100, 25_49, 25_49"};

    public Square() {
        super ("sqr", true,true, "sqr a - square the interval a. It is extended to directed intervals but needs to be verified in that case.", EXAMPLE, RESULT);
    }

    public Interval _computeIntervals(Interval i) throws Exception {
        if (i.isPositive()) return  new Interval (Math.pow(i.getLeft(),2), Math.pow(i.getRight(),2));
        if (i.isNegative()) return  new Interval (Math.pow(i.getRight(),2), Math.pow(i.getLeft(),2));
        if (i.isProper()) return  new Interval (0, Math.max(Math.pow(i.getLeft(), 2), Math.pow(i.getRight(), 2)));
        return  new Interval (Math.max(Math.pow(i.getLeft(), 2), Math.pow(i.getRight(), 2)), 0);
    }

}
