/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.set;


import engcalculator.data.Interval;
import engcalculator.function.infix.compare.ComparisonInfixFunction;

/**
 *
 * @author simone
 */
public class SuperSet extends ComparisonInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_7","6_9", "1_2", "3_4"};
    private final static String[] EXAMPLE_RIGHT = {"5_8","7_8", "1.5_3", "-3_-2"};
    private final static String[] RESULT = {"0","1","0","0"};

    public SuperSet() {
        super(">>", ">> checks if an interval is a superset of another returning 0 for false, 1 for true. Superset means every element of the second interval is available in the first (the opposite is not required).", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public boolean compare(Interval a, Interval b) throws Exception {
        return a.getLeft() <= b.getLeft() && a.getRight() >= b.getRight();
    }
}
