/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class ValTol extends PrefixFunction {
    private final static String[] EXAMPLE = {"0_10, 5_10"};
    private final static String[] RESULT = {"5, 100, 7.5, 33.333"};


    public ValTol() {
        super ("valtol", (byte) 1, true, true, "valtol computes the value and tolerance on every interval of a list of intervals.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        Interval a = input.getFirst();
        IntervalList result = new IntervalList(new Interval (new Interval(a.getVal())));
        result.add(new Interval(a.getTol()));
        return result;
    }

}
