/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.statistic;


import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;
import engcalculator.function.infix.arithmetic.Div;
import engcalculator.function.prefix.cumulative.SumUp;

/**
 *
 * @author simone
 */
public class Average extends PrefixFunction {
    private final static SumUp SUM_UP = new SumUp ();
    private final static Div DIV = new Div();
    private final static Size SIZE = new Size();
    private final static String[] EXAMPLE = {"1, 2, 3, 4"};
    private final static String[] RESULT = {"2.5"};

    public Average() {
        super("average", (byte) -1, false, true, "average returns average interval among the intervals content in a list.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        return DIV._compute(SUM_UP._compute(input), SIZE._compute(input));
    }
}
